'use strict';

var React = require('react');

var _require = require('yylib-ui'),
    YYClass = _require.YYClass;

var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

//定义META
var uiMeta = {
    name: 'searchitem',
    fields: [,
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('key', '', PropTypes.string, true, '字段的唯一标识'), field('title', '', PropTypes.string, true, '字段名称'), field('fieldtype', '', PropTypes.string, false, '字段类型'), field('inputtype', '', PropTypes.string, false, '值类型'), field('inputprops', {}, PropTypes.object, false, '值属性(参照和下拉类型时需要指定)'), field('oper', [], PropTypes.array, true, '字段允许的操作符集合'), field('required', false, PropTypes.bool, true, '是否必输条件'), field('hidden', false, PropTypes.bool, true, '是否隐藏字段'), field('enableSearch', true, PropTypes.bool, true, '是否搜索字段'), field('enableOrder', false, PropTypes.bool, true, '是否排序字段')]
};

var YYSearchItem = YYClass.create({
    uiMeta: uiMeta
});

module.exports = YYSearchItem;