'use strict';

var React = require('react');
var _ = require('lodash');

var _require = require('yylib-ui'),
    YYClass = _require.YYClass,
    YYIcon = _require.YYIcon;

var YYFilterSelected = YYClass.create({
    _handleRemove: function _handleRemove() {
        var _props = this.props,
            rowKey = _props.rowKey,
            onRmoveItems = _props.onRmoveItems;

        if (onRmoveItems) {
            onRmoveItems(rowKey);
        }
    },
    _getSelectLabel: function _getSelectLabel(selectedItems) {
        return _.map(selectedItems, function (item) {
            return item.text;
        }).join(' , ');
    },
    render: function render() {
        var selectedItems = this.props.selectedItems;

        var selectedTexts = this._getSelectLabel(selectedItems);

        return selectedTexts ? React.createElement(
            'span',
            { className: 'yyui-filter-selected' },
            selectedTexts,
            React.createElement(YYIcon, { type: 'cross', onClick: this._handleRemove })
        ) : null;
    }
});

module.exports = YYFilterSelected;