'use strict';

var React = require('react');

var _require = require('yylib-ui'),
    YYClass = _require.YYClass,
    YYPage = _require.YYPage,
    YYToolbar = _require.YYToolbar,
    YYRow = _require.YYRow,
    YYCol = _require.YYCol;

var CPListHeader = YYClass.create({
    render: function render() {
        var leftButtons = [];
        var rightButtons = [];
        var goBackBtn = null;
        var breadcrumb = null;
        var searchBar = null;
        var schemeBar = null;
        if (_.isArray(this.props.children)) {
            _.forEach(this.props.children, function (item, index) {
                if (React.isValidElement(item)) {
                    if (item.props.uitype == 'CPGoBack') {
                        goBackBtn = item; //匹配返回按钮
                    } else if (item.props.uitype == 'YYBreadcrumb') {
                        breadcrumb = item; //匹配面包屑
                    } else if (item.props.uitype == 'CPSearchBar') {
                        searchBar = item; //匹配出搜索栏
                    } else if (item.props.uitype == 'YYSchemeGroup') {
                        schemeBar = item; //查询方案栏
                    } else {
                        if (item.props.align == 'right') {
                            rightButtons.push(item);
                        } else {
                            //默认居左
                            leftButtons.push(item);
                        }
                    }
                }
            });
        }
        return React.createElement(
            YYToolbar,
            { className: 'cp2-header' },
            React.createElement(
                YYRow,
                null,
                React.createElement(
                    YYCol,
                    { span: 16, style: { display: 'flex', alignItems: 'center' } },
                    goBackBtn,
                    breadcrumb,
                    leftButtons,
                    schemeBar
                ),
                React.createElement(
                    YYCol,
                    { span: 8, style: { paddingRight: 20, alignItems: 'center', display: 'flex', flexDirection: 'row-reverse' } },
                    searchBar,
                    rightButtons
                )
            )
        );
    }
});
module.exports = CPListHeader;