'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _UrlUtils = require('yylib-utils/UrlUtils');

var _UrlUtils2 = _interopRequireDefault(_UrlUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ItemHeader = function (_React$PureComponent) {
    _inherits(ItemHeader, _React$PureComponent);

    function ItemHeader() {
        _classCallCheck(this, ItemHeader);

        return _possibleConstructorReturn(this, (ItemHeader.__proto__ || Object.getPrototypeOf(ItemHeader)).apply(this, arguments));
    }

    _createClass(ItemHeader, [{
        key: 'getClassName',
        value: function getClassName() {
            var rootPrefixCls = this.props.rootPrefixCls;

            return (0, _classnames2.default)(rootPrefixCls + '-header');
        }
    }, {
        key: 'renderContent',
        value: function renderContent(prop) {
            var _props = this.props,
                dataItem = _props.dataItem,
                customRenderDataSet = _props.customRenderDataSet;

            var content = [];
            this.props[prop].map(function (_ref) {
                var label = _ref.label,
                    dataIndex = _ref.dataIndex,
                    type = _ref.type,
                    linkUrl = _ref.linkUrl;

                if (dataItem !== null && customRenderDataSet[dataItem[dataIndex]]) {
                    content.push(customRenderDataSet[dataItem[dataIndex]].render({ dataItem: dataItem, key: dataItem[dataIndex] }));
                } else if (type === 'label') {
                    content.push(_react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('label') },
                        _react2.default.createElement(
                            'span',
                            null,
                            dataItem === null ? dataIndex : dataItem[dataIndex]
                        )
                    ));
                } else if (type === 'label-item') {
                    content.push(_react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('label-item') },
                        _react2.default.createElement(
                            'span',
                            null,
                            label
                        ),
                        _react2.default.createElement(
                            'span',
                            null,
                            dataItem === null ? dataIndex : dataItem[dataIndex]
                        )
                    ));
                } else if (type === 'hyperlink') {
                    content.push(_react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('hyperlink') },
                        _react2.default.createElement(
                            _reactRouter.Link,
                            { to: _UrlUtils2.default.fillUrlParams(linkUrl, dataItem) },
                            dataItem === null ? label : dataItem[dataIndex] ? label : null
                        )
                    ));
                }
            });
            return content;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                renderItemHeaderLeft = _props2.renderItemHeaderLeft,
                renderItemHeaderRight = _props2.renderItemHeaderRight,
                dataItem = _props2.dataItem;

            return _react2.default.createElement(
                'div',
                { className: this.getClassName() },
                _react2.default.createElement(
                    'div',
                    { className: this.getClassName() + '-left' },
                    renderItemHeaderLeft === null ? this.renderContent('itemHeaderLeftDataSet') : renderItemHeaderLeft(dataItem)
                ),
                _react2.default.createElement(
                    'div',
                    { className: this.getClassName() + '-right' },
                    renderItemHeaderRight === null ? this.renderContent('itemHeaderRightDataSet') : renderItemHeaderRight(dataItem)
                )
            );
        }
    }]);

    return ItemHeader;
}(_react2.default.PureComponent);

ItemHeader.defaultProps = {
    rootPrefixCls: 'ijz-listitem',
    dataItem: null,
    renderItemHeaderLeft: null,
    renderItemHeaderRight: null,
    itemHeaderLeftDataSet: [],
    itemHeaderRightDataSet: [],
    customRenderDataSet: null
};
exports.default = ItemHeader;