'use strict';

var React = require('react');

var _require = require('yylib-ui'),
    YYClass = _require.YYClass;

var _require2 = require('yylib-business/widgets'),
    FormItemWidget = _require2.FormItemWidget,
    FormWidget = _require2.FormWidget;

var _ = require('lodash');

var _require3 = require('./MDHandler'),
    getHandler = _require3.getHandler;

var MDFieldType = require('../../widgets/MDFieldType');
var PrintCardForm = YYClass.create({
    getDefaultProps: function getDefaultProps() {
        return {
            fields: null
        };
    },
    render: function render() {
        var _this = this;

        var _props$form = this.props.form,
            getFieldProps = _props$form.getFieldProps,
            setFieldsValue = _props$form.setFieldsValue,
            getFieldsValue = _props$form.getFieldsValue;

        // 页面字段

        var fieldCmps = [];
        _.forEach(this.props.fields, function (field, index) {
            //组件属性
            var _props = _.assign({}, field, { props: field.props }, getFieldProps(field.uikey), { label: field.uititle });
            if (_props.uisubtype == 'currency') {
                _props.type = 'currency';
            }
            _props.uisubtype = MDFieldType.plaintext;
            //index是奇数并且不是最后两个（每行第一个并且不是不是最后一行的字段）
            if ((index + 1) % 2 == 1 && index < _this.props.fields.length - 2) {
                _props.className = 'item-border-bottom item-border-right';
            }
            //index是偶数并且不是最后一个（每行第二个并且不是不是最后一行的字段）
            else if ((index + 1) % 2 == 0 && index < _this.props.fields.length - 1) {
                    _props.className = 'item-border-bottom';
                } else if ((index + 1) % 2 == 1) {
                    _props.className = 'item-border-right';
                }
            fieldCmps.push(React.createElement(FormItemWidget, _props));
        });
        return React.createElement(
            FormWidget,
            { colnumber: '2', className: 'print-card-form' },
            fieldCmps
        );
    }
});

module.exports = PrintCardForm;