'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Created by Dio on 2016/7/21.
 * 手风琴组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');

var _require = require('react-dom'),
    findDOMNode = _require.findDOMNode;

var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
var RcCollapse = require('rc-collapse');
var RcAccordion = RcCollapse.Panel;
var YYStepsTarget = require('../../business/stepsnav/YYStepsTarget');
//定义META
var uiMeta = {
    name: 'accordion',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('key', undefined, PropTypes.string, false, '对应 activeKey'), field('isOpen', false, PropTypes.bool, false, '默认是否展开，注意isOpen不能于YYAccordions.defaultActiveKey|activeKey并行使用'), field('header', null, PropTypes.oneOfType([PropTypes.element, PropTypes.string]), false, '面板头内容'), field('enableStepTarget', false, PropTypes.bool, false, '是否启用步骤导航链接功能'), field('visible', true, PropTypes.bool, false, '是否显示')]
};
var YYAccordion = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var _props = this.props,
            enableStepTarget = _props.enableStepTarget,
            header = _props.header,
            uikey = _props.uikey,
            style = _props.style,
            visible = _props.visible;

        var _header = header;
        if (enableStepTarget == true) {
            _header = React.createElement(
                YYStepsTarget,
                { targetKey: uikey },
                header
            );
        }
        var _style = _.assign({}, style);
        if (visible === false) _style.display = 'none';
        return React.createElement(
            RcAccordion,
            _extends({}, this.props, { style: _style, header: _header }),
            this.props.children
        );
    }
});
module.exports = YYAccordion;